Option Explicit On 
Option Strict On

Public Class frmHowTo9_2
    Inherits CustomerClasses.frmHowTo9xBase

    Private mCustomer As New CCustomer9_2()

    Protected Overrides Sub TextBoxChange(ByVal pstrProperty As String, ByVal pstrValue As String)

        Try

            Select Case pstrProperty

                Case "Address"
                    mCustomer.Address = pstrValue

                Case "CompanyName"
                    mCustomer.CompanyName = pstrValue

                Case "ContactTitle"
                    mCustomer.ContactTitle = pstrValue

                Case "ContactName"
                    mCustomer.ContactName = pstrValue

                Case "City"
                    mCustomer.City = pstrValue

                Case "Zip"
                    mCustomer.PostalCode = pstrValue

                Case "Country"
                    mCustomer.Country = pstrValue

                Case "Region"
                    mCustomer.Region = pstrValue

                Case "Phone"
                    mCustomer.Phone = pstrValue

                Case "Fax"
                    mCustomer.Fax = pstrValue

            End Select

            ' Write the class' properties to the RichTextBox
            ' to aid debugging.
            Me.rtbToString.Text = mCustomer.ToString()

        Catch ex As NullReferenceException
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.SuspendLayout()
        '
        'btnNew
        '
        Me.btnNew.Visible = True
        '
        'btnDelete
        '
        Me.btnDelete.Visible = True
        '
        'btnSave
        '
        Me.btnSave.Visible = True
        '
        'btnRetrieve
        '
        Me.btnRetrieve.Visible = True
        '
        'txtFax
        '
        Me.txtFax.Visible = True
        '
        'txtPhone
        '
        Me.txtPhone.Visible = True
        '
        'txtRegion
        '
        Me.txtRegion.Visible = True
        '
        'txtCountry
        '
        Me.txtCountry.Visible = True
        '
        'txtZip
        '
        Me.txtZip.Visible = True
        '
        'txtCity
        '
        Me.txtCity.Visible = True
        '
        'txtAddress
        '
        Me.txtAddress.Visible = True
        '
        'txtContactTitle
        '
        Me.txtContactTitle.Visible = True
        '
        'txtCustomerID
        '
        Me.txtCustomerID.Visible = True
        '
        'txtCompanyName
        '
        Me.txtCompanyName.Visible = True
        '
        'txtContactName
        '

        Me.txtContactName.Visible = True
        '
        'frmHowTo9_2
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(688, 325)
        Me.Name = "frmHowTo9_2"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub frmHowTo9_2_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.txtPhone.Text = "505-555-1212"
        Me.txtContactName.Text = "Finnegan M. Ramos O'Neill"
        Me.txtContactTitle.Text = "Proprietor"
        Me.txtCompanyName.Text = "Finn's Fabulous Foodstuffs"
        Me.txtAddress.Text = "1234 Rio Grande Boulevard"
        Me.txtCity.Text = "Albuquerque"
    End Sub
End Class

Public Class CCustomer9_2
    Implements ICustomer
#Region "Class Variables"
    Private mstrCustomerID As String
    Private mstrCompanyName As String
    Private mstrContactName As String
    Private mstrContactTitle As String
    Private mstrAddress As String
    Private mstrCity As String
    Private mstrRegion As String
    Private mstrCountry As String
    Private mstrPostalCode As String
    Private mstrPhone As String
    Private mstrFax As String
#End Region
#Region "Properties"
    Public ReadOnly Property CustomerID() As String Implements ICustomer.CustomerID
        Get
            Return mstrCustomerID
        End Get
    End Property

    Public Property CompanyName() As String Implements ICustomer.CompanyName
        Get
            Return mstrCompanyName
        End Get
        Set(ByVal Value As String)
            mstrCompanyName = Value
        End Set
    End Property

    Public Property ContactName() As String Implements ICustomer.ContactName
        Get
            Return mstrContactName
        End Get
        Set(ByVal Value As String)
            mstrContactName = Value
        End Set
    End Property

    Public Property ContactTitle() As String Implements ICustomer.ContactTitle
        Get
            Return mstrContactTitle
        End Get
        Set(ByVal Value As String)
            mstrContactTitle = Value
        End Set
    End Property

    Public Property Address() As String Implements ICustomer.Address
        Get
            Return mstrAddress
        End Get
        Set(ByVal Value As String)
            mstrAddress = Value
        End Set
    End Property

    Public Property City() As String Implements ICustomer.City
        Get
            Return mstrCity
        End Get
        Set(ByVal Value As String)
            mstrCity = Value
        End Set
    End Property

    Public Property Region() As String Implements ICustomer.Region
        Get
            Return mstrRegion
        End Get
        Set(ByVal Value As String)
            mstrRegion = Value
        End Set
    End Property

    Public Property PostalCode() As String Implements ICustomer.PostalCode
        Get
            Return mstrPostalCode
        End Get
        Set(ByVal Value As String)
            mstrPostalCode = Value
        End Set
    End Property

    Property Country() As String Implements ICustomer.Country
        Get
            Return mstrCountry
        End Get
        Set(ByVal Value As String)
            mstrCountry = Value
        End Set
    End Property

    Public Property Phone() As String Implements ICustomer.Phone
        Get
            Return mstrPhone
        End Get
        Set(ByVal Value As String)
            mstrPhone = Value
        End Set
    End Property

    Public Property Fax() As String Implements ICustomer.Fax
        Get
            Return mstrFax
        End Get
        Set(ByVal Value As String)
            mstrFax = Value
        End Set
    End Property

#End Region
#Region "Methods"
    Public Overrides Function toString() As String Implements ICustomer.ToString
        Dim strReturn As String
        strReturn = Me.CustomerID & vbCrLf
        strReturn = strReturn & "Company:     " & Me.CompanyName & vbCrLf
        strReturn = strReturn & "Contact:     " & Me.ContactName & vbCrLf
        strReturn = strReturn & "Title:       " & Me.ContactTitle & vbCrLf
        strReturn = strReturn & "Address:     " & Me.Address & vbCrLf
        strReturn = strReturn & "City:        " & Me.City & vbCrLf
        strReturn = strReturn & "Postal Code: " & Me.PostalCode & vbCrLf
        strReturn = strReturn & "Country:     " & Me.Country & vbCrLf
        strReturn = strReturn & "Phone:       " & Me.Phone & vbCrLf
        strReturn = strReturn & "Fax:         " & Me.Fax & vbCrLf
        strReturn = strReturn & "Region       " & Me.Region & vbCrLf
        Return strReturn
    End Function



    Public Function save() As Boolean Implements ICustomer.Save

    End Function
    Public Function delete() As Boolean Implements ICustomer.Delete

    End Function

#End Region
End Class
