Option Explicit On 
Option Strict On

Public Interface ICustomer

#Region "Properties"
    'Define properties for this interface
    'that match the table structure in name and data type
    ReadOnly Property CustomerID() As String
    Property CompanyName() As String
    Property ContactName() As String
    Property ContactTitle() As String
    Property Address() As String
    Property City() As String
    Property Region() As String
    Property PostalCode() As String
    Property Country() As String
    Property Phone() As String
    Property Fax() As String
#End Region

#Region "Methods"
    'To update record, a user would have needed to
    'retrieve data before modifying any of the properties.
    Function Save() As Boolean
    Function Delete() As Boolean
    Function ToString() As String

#End Region

End Interface
